"""
This file was autogenerated by genproperties.py

LINSTOR - management of distributed storage/DRBD9 resources
Copyright (C) 2017 - 2024  LINBIT HA-Solutions GmbH
Author: Rene Peinthor, Gabor Hernadi

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
import linstor.sharedconsts as consts
properties = \
{   u'controller': [   {   u'info': u'Range for auto-allocation of resource TCP ports',
                           u'key': consts.KEY_TCP_PORT_AUTO_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'info': u'Range for auto-allocation of volume minor numbers',
                           u'key': consts.KEY_MINOR_NR_AUTO_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'info': u'Range for auto-allocation of TCP ports for special satellites',
                           u'key': consts.KEY_SPEC_STLT_PORT_AUTO_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'info': u'DRBD peer slots to allocate for newly created resources (default 7), the number of peer slots cannot be changed once the resource is created, so allow sufficient slots to increase redundancy in the future',
                           u'key': consts.KEY_PEER_SLOTS_NEW_RESOURCE,
                           u'max': 31,
                           u'min': 1,
                           u'type': u'range'},
                       {   u'info': u'Enable dmstats on lvm create',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_DMSTATS,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Disable Prometheus /metrics on HTTP, if HTTPS is enabled',
                           u'internal': False,
                           u'key': consts.NAMESPC_REST + '/' + consts.KEY_DISABLE_HTTP_METRICS,
                           u'type': u'boolean_true_false'},
                       {   u'default': 60,
                           u'info': u'Time a node can be offline before it is declared EVICTED in minutes',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_AFTER_TIME,
                           u'type': u'long'},
                       {   u'default': 34,
                           u'info': u'Percentage(0-100) of nodes that can disconnect at the same time without the controller stopping the max_offline_time timer',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_MAX_DISCONNECTED_NODES,
                           u'max': 100,
                           u'min': 0,
                           u'type': u'range'},
                       {   u'default': u'The place count set for the resource group',
                           u'info': u'The minimum amount of replicas that should be present for a resource at all times.',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_MIN_REPLICA_COUNT,
                           u'type': u'long'},
                       {   u'default': u'true',
                           u'info': u'If set to false on a node, it cannot be evicted anymore',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_ALLOW_EVICTION,
                           u'type': u'boolean_true_false'},
                       {   u'default': u'rdma',
                           u'info': u'NVMe transportation type',
                           u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_TR_TYPE,
                           u'type': u'symbol',
                           u'values': [u'rdma', u'tcp']},
                       {   u'info': u'NVMe port',
                           u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PORT,
                           u'max': 65535,
                           u'min': 1,
                           u'type': u'range'},
                       {   u'info': u'Preferred network interface to use',
                           u'internal': False,
                           u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PREF_NIC,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'internal': True,
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_WAIT_TIMEOUT_AFTER_CREATE,
                           u'type': u'regex',
                           u'value': u'[0-9]+'},
                       {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                           u'internal': False,
                           u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                           u'type': u'long'},
                       {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                           u'internal': False,
                           u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                           u'type': u'long'},
                       {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                           u'internal': False,
                           u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                           u'type': u'long'},
                       {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                           u'internal': False,
                           u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                           u'type': u'long'},
                       {   u'info': u'Search domain node names, if no FQDN is given.',
                           u'internal': False,
                           u'key': consts.KEY_SEARCH_DOMAIN,
                           u'type': u'string'},
                       {   u'info': u'Wait timeout for an external command in milliseconds',
                           u'internal': False,
                           u'key': consts.KEY_EXT_CMD_WAIT_TO,
                           u'type': u'long'},
                       {   u'info': u"Enables automatic setting of the 'quorum' and 'on-no-quorum' property",
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_QUORUM,
                           u'type': u'symbol',
                           u'values': [   u'io-error',
                                          u'suspend-io',
                                          u'disabled']},
                       {   u'info': u'Enables automatic management (creation and deletion) of tie breaking resource',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_ADD_QUORUM_TIEBREAKER,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Makes a resource diskful if it was continuously diskless primary for X minutes',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL,
                           u'type': u'long'},
                       {   u'info': u'Allows this resource to be cleaned up after toggle-disk + resync is finished',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL_ALLOW_CLEANUP,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'If set to true it will disable automatic setting of DRBD resync-after options',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_DISABLE_AUTO_RESYNC_AFTER,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'If set to true it will disable automatic setting of DRBD verify algorithm',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_DISABLE_AUTO_VERIFY_ALGO,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'A list of verify algorithms allowed by user, semicolon separated',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_VERIFY_ALGO_ALLOWED_USER,
                           u'type': u'string'},
                       {   u'info': u'If set to false it will disable automatic setting of DRBD rs-discard-granularity. If not set or set to true, automatically setting the rs-discard-granularity property might override previously values specified by the user on volume-definition level',
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_RS_DISCARD_GRANULARITY,
                           u'type': u'string'},
                       {   u'info': u"Appends '--skip-disk' to 'drbdadm adjust' commands. Is automatically set if a disk failure is detected. In order to disable, remove this property",
                           u'internal': False,
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_SKIP_DISK,
                           u'type': u'symbol',
                           u'values': [u'True']},
                       {   u'info': u'Linstor storage pool name for writecache',
                           u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_POOL_NAME,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'info': u'Size of the writecache in % (0-100) or KiB otherwise',
                           u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_SIZE,
                           u'type': u'regex',
                           u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                       {   u'default': u'0',
                           u'info': u'offset from the start of cache device in 512-byte sectors',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_START_SECTOR,
                           u'type': u'long'},
                       {   u'default': u'50',
                           u'info': u'start writeback when the number of used blocks reach this watermark',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_HIGH_WATERMARK,
                           u'type': u'long'},
                       {   u'default': u'45',
                           u'info': u'stop writeback when the number of used blocks drops below this watermark',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_LOW_WATERMARK,
                           u'type': u'long'},
                       {   u'default': u'unlimited',
                           u'info': u'limit the number of blocks that are in flight during writeback. Setting this value reduces writeback throughput, but it may improve latency of read requests',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_WRITEBACK_JOBS,
                           u'type': u'long'},
                       {   u'default': u'64 for pmem, 65536 for ssd',
                           u'info': u'when the application writes this amount of blocks without issuing the FLUSH request, the blocks are automatically committed',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_BLOCKS,
                           u'type': u'long'},
                       {   u'default': u'1000',
                           u'info': u'autocommit time in milliseconds. The data is automatically committed if this time passes and no FLUSH request is received',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_TIME,
                           u'type': u'long'},
                       {   u'default': u'On',
                           u'info': u'"On" results in "fua" as argument, whereas the value "Off" results in "nofua" argument',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_FUA,
                           u'type': u'symbol',
                           u'values': [u'On', u'Off']},
                       {   u'info': u'Additional arguments passed through',
                           u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_ADDITIONAL,
                           u'type': u'string'},
                       {   u'default': u'writethrough',
                           u'info': u'Operation mode',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_OPERATING_MODE,
                           u'type': u'symbol',
                           u'values': [   u'writeback',
                                          u'writethrough',
                                          u'passthrough']},
                       {   u'info': u'Name of the storage pool used for the cache metadata. If not specified, this will default to the CachePool property',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_POOL_NAME,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'default': u'12288',
                           u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_SIZE,
                           u'type': u'regex',
                           u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                       {   u'info': u'Name of the storage pool used for the cache cache device',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_POOL_NAME,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'default': u'5%',
                           u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_SIZE,
                           u'type': u'regex',
                           u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                       {   u'default': u'4096',
                           u'info': u'Block size',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_BLOCK_SIZE,
                           u'type': u'long'},
                       {   u'default': u'smq',
                           u'info': u'Replacement policy',
                           u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_POLICY,
                           u'type': u'symbol',
                           u'values': [u'mq', u'smq', u'cleaner']},
                       {   u'info': u'Name of the storage pool used for the bcache',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_POOL_NAME,
                           u'type': u'regex',
                           u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                       {   u'default': u'5%',
                           u'info': u'Size of the cache in % (0-100) or KiB otherwise. Minimum 524288',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_SIZE,
                           u'type': u'regex',
                           u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                       {   u'info': u'Block size',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BLOCKSIZE,
                           u'type': u'long'},
                       {   u'info': u'Bucket size',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BUCKETSIZE,
                           u'type': u'long'},
                       {   u'info': u'Data offset',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DATA_OFFSET,
                           u'type': u'long'},
                       {   u'info': u'Enable writeback if set to true',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_WRITEBACK,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Enable discard if set to true',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DISCARD,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Cache replacement policy. Default: lru',
                           u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_CACHE_REPLACEMENT_POLICY,
                           u'type': u'symbol',
                           u'values': [u'lru', u'fifo']},
                       {   u'info': u"Additional parameters added to every 'lvcreate ... ' command",
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_OPTIONS,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'info': u"Additional parameters added to every 'lvcreate --snapshot ... ' command",
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_SNAPSHOT_OPTIONS,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'info': u"Additional parameters added to every 'zfs create ... ' command",
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_CREATE_OPTIONS,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'info': u"Additional parameters added to every 'zfs snapshot ... ' command",
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_SNAPSHOT_OPTIONS,
                           u'type': u'regex',
                           u'value': u'.*'},
                       {   u'info': u'Remote SPDK API host name',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_HOST,
                           u'type': u'regex',
                           u'value': u'.+'},
                       {   u'info': u'Remote SPDK API port',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_PORT,
                           u'type': u'regex',
                           u'value': u'[0-9]+'},
                       {   u'info': u'Remote SPDK API user name',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME,
                           u'type': u'regex',
                           u'value': u'.+'},
                       {   u'info': u'Environment variable containing remote SPDK API user name',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME_ENV,
                           u'type': u'regex',
                           u'value': u'.+'},
                       {   u'info': u'Remote SPDK API password',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW,
                           u'type': u'regex',
                           u'value': u'.+'},
                       {   u'info': u'Environment variable containing remote SPDK API password',
                           u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW_ENV,
                           u'type': u'regex',
                           u'value': u'.+'},
                       {   u'info': u'linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)',
                           u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_VLM_TYPE,
                           u'type': u'symbol',
                           u'values': [u'linear', u'virtual']},
                       {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                           u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                           u'type': u'string'},
                       {   u'default': u'1.0',
                           u'info': u"Weight of 'MaxFreeSpace' autoplacer-strategy",
                           u'key': consts.NAMESPC_AUTOPLACER_WEIGHTS + '/' + consts.KEY_AUTOPLACE_STRAT_WEIGHT_MAX_FREESPACE,
                           u'type': u'regex',
                           u'value': u'^[0-9]+([.][0-9]+)?'},
                       {   u'default': u'0.0',
                           u'info': u"Weight of 'MinReservedSpace' autoplacer-strategy",
                           u'key': consts.NAMESPC_AUTOPLACER_WEIGHTS + '/' + consts.KEY_AUTOPLACE_STRAT_WEIGHT_MIN_RESERVED_SPACE,
                           u'type': u'regex',
                           u'value': u'^[0-9]+([.][0-9]+)?'},
                       {   u'default': u'0.0',
                           u'info': u"Weight of 'MinRscCount' autoplacer-strategy",
                           u'key': consts.NAMESPC_AUTOPLACER_WEIGHTS + '/' + consts.KEY_AUTOPLACE_STRAT_WEIGHT_MIN_RSC_COUNT,
                           u'type': u'regex',
                           u'value': u'^[0-9]+([.][0-9]+)?'},
                       {   u'default': u'0.0',
                           u'info': u"Weight of 'MaxThroughput' autoplacer-strategy",
                           u'key': consts.NAMESPC_AUTOPLACER_WEIGHTS + '/' + consts.KEY_AUTOPLACE_MAX_THROUGHPUT,
                           u'type': u'regex',
                           u'value': u'^[0-9]+([.][0-9]+)?'},
                       {   u'info': u'Filename of the preselection script. File must be in /etc/linstor/selector/',
                           u'key': consts.NAMESPC_AUTOPLACER + '/' + consts.KEY_AUTOPLACE_PRE_SELECT_FILE_NAME,
                           u'type': u'string'},
                       {   u'default': u'5000',
                           u'info': u'Timeout in ms Linstor waits for the script to run.',
                           u'key': consts.NAMESPC_AUTOPLACER + '/' + consts.KEY_AUTOPLACE_PRE_SELECT_SCRIPT_TIMEOUT,
                           u'type': u'long'},
                       {   u'info': u'The maximum throughput the given storage pool is capable of.',
                           u'key': consts.NAMESPC_AUTOPLACER + '/' + consts.KEY_AUTOPLACE_MAX_THROUGHPUT,
                           u'type': u'long'},
                       {   u'info': u'Specifies if the storagepool(s) of the given node can be targeted by the autoplacer',
                           u'key': consts.KEY_AUTOPLACE_ALLOW_TARGET,
                           u'type': u'boolean_true_false'},
                       {   u'default': u'false',
                           u'internal': True,
                           u'key': consts.NAMESPC_DRBD_PROXY + '/' + consts.KEY_DRBD_PROXY_AUTO_ENABLE,
                           u'type': u'boolean_true_false'},
                       {   u'internal': True,
                           u'key': consts.KEY_SITE,
                           u'type': u'string'},
                       {   u'default': u'180',
                           u'info': u'Interval for space cache background updates in seconds',
                           u'key': consts.KEY_UPDATE_CACHE_INTERVAL,
                           u'type': u'long'},
                       {   u'info': u'Range for allocation of snapshot shipping TCP ports',
                           u'key': consts.NAMESPC_SNAPSHOT_SHIPPING + '/' + consts.KEY_TCP_PORT_RANGE,
                           u'type': u'regex',
                           u'value': u'[0-9]+-[0-9]+'},
                       {   u'default': u'5',
                           u'info': u'The timeout in seconds to be used for API-requests during backup list and backup delete',
                           u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_BACKUP_TIMEOUT,
                           u'type': u'long',
                           u'unit': u'seconds'},
                       {   u'default': u'',
                           u'info': u'A suffix to be appended in order to distiguish same backup names from different Linstor clusters',
                           u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_BACKUP_S3_SUFFIX,
                           u'type': u'string'},
                       {   u'default': u'-1',
                           u'info': u'The maximum number of backups that can be shipped at the same time per node, negative means no limit',
                           u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_MAX_CONCURRENT_BACKUPS_PER_NODE,
                           u'type': u'long'},
                       {   u'default': u'false',
                           u'info': u'If true, an existing resource can be deleted in order to restore a received backup',
                           u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_ALLOW_FORCE_RESTORE,
                           u'type': u'string'},
                       {   u'default': u'false',
                           u'info': u'if true: Zfs clone will use snapshot clone, instead of send/receive',
                           u'key': consts.KEY_USE_ZFS_CLONE,
                           u'type': u'boolean_true_false'},
                       {   u'default': u'false',
                           u'info': u'Allow mixing storage pool drivers for migration purpose',
                           u'key': consts.KEY_RSC_ALLOW_MIXING_DEVICE_KIND,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Runs every X minutes an snapshot-creation. Removing this property or having a value <= 0 disables auto-snapshotting.',
                           u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_RUN_EVERY,
                           u'type': u'long'},
                       {   u'default': u'10',
                           u'info': u'Keeps the last X auto-snapshots. Removing this property or having a value <= 0 disables auto-cleanup, all auto-snapshots will be kept',
                           u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_KEEP,
                           u'type': u'long'},
                       {   u'info': u'The next ID to try for auto-snapshots',
                           u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_AUTO_SNAPSHOT_NEXT_ID,
                           u'type': u'long'},
                       {   u'default': u'gp2',
                           u'info': u'Sets the Volume Type for the EBS device (like gp2, gp3, etc..)',
                           u'key': consts.KEY_EBS_VOLUME_TYPE,
                           u'type': u'string'},
                       {   u'default': u'false',
                           u'info': u'Forces any thin volumes to do the initial sync. Any resources created while this is true will behave so permanently.',
                           u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_FORCE_INITIAL_SYNC,
                           u'type': u'boolean_true_false'},
                       {   u'info': u'Default value for MaxFreeCapacityOversubscriptionRatio and MaxTotalCapacityOversubscriptionRatio (default 20)',
                           u'key': consts.KEY_STOR_POOL_MAX_OVERSUBSCRIPTION_RATIO,
                           u'max_float': 1000.0,
                           u'min_float': 0.0,
                           u'type': u'range-float'},
                       {   u'info': u'Maximum allowed ratio the remaining free space can be overprovisioned (default 20)',
                           u'key': consts.KEY_STOR_POOL_MAX_FREE_CAPACITY_OVERSUBSCRIPTION_RATIO,
                           u'max_float': 1000.0,
                           u'min_float': 0.0,
                           u'type': u'range-float'},
                       {   u'info': u'Maximum allowed ratio the capacity can be overprovisioned (default 20)',
                           u'key': consts.KEY_STOR_POOL_MAX_TOTAL_CAPACITY_OVERSUBSCRIPTION_RATIO,
                           u'max_float': 1000.0,
                           u'min_float': 0.0,
                           u'type': u'range-float'},
                       {   u'default': u'true',
                           u'info': u'If set to false it will disable the balance resource task',
                           u'internal': False,
                           u'key': consts.KEY_BALANCE_RESOURCES_ENABLED,
                           u'type': u'boolean_true_false'},
                       {   u'default': u'3600',
                           u'info': u'Interval between balance resources task runs',
                           u'key': consts.KEY_BALANCE_RESOURCES_INTERVAL,
                           u'type': u'long'},
                       {   u'default': u'3600',
                           u'info': u'Seconds a resource must exists before balance resource task might delete it',
                           u'key': consts.KEY_BALANCE_RESOURCES_GRACE_PERIOD,
                           u'type': u'long'},
                       {   u'drbd_option_name': u'read-balancing',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/read-balancing",
                           u'type': u'symbol',
                           u'values': [   u'prefer-local',
                                          u'prefer-remote',
                                          u'round-robin',
                                          u'least-pending',
                                          u'when-congested-remote',
                                          u'32K-striping',
                                          u'64K-striping',
                                          u'128K-striping',
                                          u'256K-striping',
                                          u'512K-striping',
                                          u'1M-striping']},
                       {   u'drbd_option_name': u'on-io-error',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/on-io-error",
                           u'type': u'symbol',
                           u'values': [   u'pass_on',
                                          u'call-local-io-error',
                                          u'detach']},
                       {   u'default': True,
                           u'drbd_option_name': u'disk-drain',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-drain",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'resync-after',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/resync-after",
                           u'type': u'string'},
                       {   u'default': 0,
                           u'drbd_option_name': u'disk-timeout',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-timeout",
                           u'max': 6000,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': False,
                           u'drbd_option_name': u'disable-write-same',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disable-write-same",
                           u'type': u'boolean'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rs-discard-granularity',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/rs-discard-granularity",
                           u'max': 1048576,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': True,
                           u'drbd_option_name': u'disk-flushes',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-flushes",
                           u'type': u'boolean'},
                       {   u'default': 1237,
                           u'drbd_option_name': u'al-extents',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/al-extents",
                           u'max': 65534,
                           u'min': 67,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': True,
                           u'drbd_option_name': u'al-updates',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/al-updates",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'md-flushes',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/md-flushes",
                           u'type': u'boolean'},
                       {   u'default': False,
                           u'drbd_option_name': u'disk-barrier',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/disk-barrier",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'discard-zeroes-if-aligned',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                           u'type': u'boolean'},
                       {   u'default': 100,
                           u'drbd_option_name': u'c-fill-target',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-fill-target",
                           u'max': 1048576,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'default': 102400,
                           u'drbd_option_name': u'c-max-rate',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-max-rate",
                           u'max': 4194304,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': 250,
                           u'drbd_option_name': u'resync-rate',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/resync-rate",
                           u'max': 8388608,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': 10,
                           u'drbd_option_name': u'c-delay-target',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-delay-target",
                           u'max': 100,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 250,
                           u'drbd_option_name': u'c-min-rate',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-min-rate",
                           u'max': 4194304,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes/second',
                           u'unit_prefix': u'k'},
                       {   u'default': True,
                           u'drbd_option_name': u'bitmap',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/bitmap",
                           u'type': u'boolean'},
                       {   u'default': 20,
                           u'drbd_option_name': u'c-plan-ahead',
                           u'drbd_res_file_section': u'disk',
                           u'internal': True,
                           u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                           u'max': 300,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 100,
                           u'drbd_option_name': u'peer-ack-delay',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/peer-ack-delay",
                           u'max': 10000,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'milliseconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'quorum-minimum-redundancy',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/quorum-minimum-redundancy",
                           u'max': u'32',
                           u'min': u'1',
                           u'type': u'numeric-or-symbol',
                           u'values': [u'off', u'majority', u'all']},
                       {   u'default': 8000,
                           u'drbd_option_name': u'max-io-depth',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/max-io-depth",
                           u'max': 4294967295,
                           u'min': 4,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 20,
                           u'drbd_option_name': u'auto-promote-timeout',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/auto-promote-timeout",
                           u'max': 600,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'quorum',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/quorum",
                           u'max': u'32',
                           u'min': u'1',
                           u'type': u'numeric-or-symbol',
                           u'values': [u'off', u'majority', u'all']},
                       {   u'drbd_option_name': u'on-no-data-accessible',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/on-no-data-accessible",
                           u'type': u'symbol',
                           u'values': [u'io-error', u'suspend-io']},
                       {   u'default': True,
                           u'drbd_option_name': u'auto-promote',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/auto-promote",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'cpu-mask',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/cpu-mask",
                           u'type': u'string'},
                       {   u'default': 300,
                           u'drbd_option_name': u'twopc-timeout',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/twopc-timeout",
                           u'max': 600,
                           u'min': 50,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 1,
                           u'drbd_option_name': u'twopc-retry-timeout',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/twopc-retry-timeout",
                           u'max': 50,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'on-suspended-primary-outdated',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/on-suspended-primary-outdated",
                           u'type': u'symbol',
                           u'values': [u'disconnect', u'force-secondary']},
                       {   u'default': 4096,
                           u'drbd_option_name': u'peer-ack-window',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/peer-ack-window",
                           u'max': 204800,
                           u'min': 2048,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'drbd_option_name': u'on-no-quorum',
                           u'drbd_res_file_section': u'options',
                           u'internal': True,
                           u'key': "DrbdOptions/Resource/on-no-quorum",
                           u'type': u'symbol',
                           u'values': [u'io-error', u'suspend-io']},
                       {   u'default': False,
                           u'drbd_option_name': u'load-balance-paths',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/load-balance-paths",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'protocol',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/protocol",
                           u'type': u'symbol',
                           u'values': [u'A', u'B', u'C']},
                       {   u'default': 2048,
                           u'drbd_option_name': u'max-epoch-size',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/max-epoch-size",
                           u'max': 20000,
                           u'min': 1,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': False,
                           u'drbd_option_name': u'allow-two-primaries',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/allow-two-primaries",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'after-sb-0pri',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-0pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'discard-younger-primary',
                                          u'discard-older-primary',
                                          u'discard-zero-changes',
                                          u'discard-least-changes',
                                          u'discard-local',
                                          u'discard-remote']},
                       {   u'default': 7,
                           u'drbd_option_name': u'ko-count',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ko-count",
                           u'max': 200,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'data-integrity-alg',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/data-integrity-alg",
                           u'type': u'string'},
                       {   u'default': 5,
                           u'drbd_option_name': u'ping-timeout',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ping-timeout",
                           u'max': 300,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'sndbuf-size',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/sndbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'transport',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/transport",
                           u'type': u'string'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rdma-ctrl-sndbuf-size',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rdma-ctrl-sndbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'tls-keyring',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tls-keyring",
                           u'type': u'string'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rcvbuf-size',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rcvbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 2048,
                           u'drbd_option_name': u'max-buffers',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/max-buffers",
                           u'max': 131072,
                           u'min': 32,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'fencing',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/fencing",
                           u'type': u'symbol',
                           u'values': [   u'dont-care',
                                          u'resource-only',
                                          u'resource-and-stonith']},
                       {   u'drbd_option_name': u'csums-alg',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/csums-alg",
                           u'type': u'string'},
                       {   u'default': False,
                           u'drbd_option_name': u'always-asbp',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/always-asbp",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'tls-privkey',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tls-privkey",
                           u'type': u'string'},
                       {   u'default': 1237,
                           u'drbd_option_name': u'congestion-extents',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/congestion-extents",
                           u'max': 65534,
                           u'min': 67,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'on-congestion',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/on-congestion",
                           u'type': u'symbol',
                           u'values': [   u'block',
                                          u'pull-ahead',
                                          u'disconnect']},
                       {   u'default': 0,
                           u'drbd_option_name': u'rdma-ctrl-rcvbuf-size',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rdma-ctrl-rcvbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 10,
                           u'drbd_option_name': u'ping-int',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/ping-int",
                           u'max': 120,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'seconds',
                           u'unit_prefix': u'1'},
                       {   u'default': False,
                           u'drbd_option_name': u'tls',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tls",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'rr-conflict',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/rr-conflict",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'call-pri-lost',
                                          u'violently',
                                          u'retry-connect',
                                          u'auto-discard']},
                       {   u'default': True,
                           u'drbd_option_name': u'tcp-cork',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tcp-cork",
                           u'type': u'boolean'},
                       {   u'default': True,
                           u'drbd_option_name': u'use-rle',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/use-rle",
                           u'type': u'boolean'},
                       {   u'default': False,
                           u'drbd_option_name': u'csums-after-crash-only',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/csums-after-crash-only",
                           u'type': u'boolean'},
                       {   u'default': 0,
                           u'drbd_option_name': u'socket-check-timeout',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/socket-check-timeout",
                           u'max': 300,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'congestion-fill',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/congestion-fill",
                           u'max': 20971520,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u's'},
                       {   u'drbd_option_name': u'cram-hmac-alg',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/cram-hmac-alg",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'verify-alg',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/verify-alg",
                           u'type': u'string'},
                       {   u'default': True,
                           u'drbd_option_name': u'allow-remote-read',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/allow-remote-read",
                           u'type': u'boolean'},
                       {   u'drbd_option_name': u'shared-secret',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/shared-secret",
                           u'type': u'string'},
                       {   u'default': 10,
                           u'drbd_option_name': u'connect-int',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/connect-int",
                           u'max': 120,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'tls-certificate',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/tls-certificate",
                           u'type': u'string'},
                       {   u'default': 60,
                           u'drbd_option_name': u'timeout',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/timeout",
                           u'max': 600,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'},
                       {   u'drbd_option_name': u'after-sb-2pri',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-2pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'call-pri-lost-after-sb',
                                          u'violently-as0p']},
                       {   u'drbd_option_name': u'after-sb-1pri',
                           u'drbd_res_file_section': u'net',
                           u'internal': True,
                           u'key': "DrbdOptions/Net/after-sb-1pri",
                           u'type': u'symbol',
                           u'values': [   u'disconnect',
                                          u'consensus',
                                          u'discard-secondary',
                                          u'call-pri-lost-after-sb',
                                          u'violently-as0p']},
                       {   u'drbd_option_name': u'after-resync-target',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/after-resync-target",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'before-resync-target',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/before-resync-target",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'before-resync-source',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/before-resync-source",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'out-of-sync',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/out-of-sync",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'quorum-lost',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/quorum-lost",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'fence-peer',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/fence-peer",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'unfence-peer',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/unfence-peer",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'initial-split-brain',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/initial-split-brain",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'local-io-error',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/local-io-error",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-lost',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-lost",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-lost-after-sb',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-lost-after-sb",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'pri-on-incon-degr',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/pri-on-incon-degr",
                           u'type': u'string'},
                       {   u'drbd_option_name': u'split-brain',
                           u'drbd_res_file_section': u'handlers',
                           u'internal': True,
                           u'key': "DrbdOptions/Handlers/split-brain",
                           u'type': u'string'}],
    u'drbd-proxy': [   {   u'default': 16777216,
                           u'drbd_option_name': u'memlimit',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/memlimit",
                           u'max': 9223372036854775807,
                           u'min': 16777216,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'read-loops',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/read-loops",
                           u'max': 2147483647,
                           u'min': 0,
                           u'type': u'range',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'sndbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/sndbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 0,
                           u'drbd_option_name': u'rcvbuf-size',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/rcvbuf-size",
                           u'max': 10485760,
                           u'min': 0,
                           u'type': u'range',
                           u'unit': u'bytes',
                           u'unit_prefix': u'1'},
                       {   u'default': 200,
                           u'drbd_option_name': u'ping-timeout',
                           u'internal': True,
                           u'key': "DrbdOptions/Proxy/ping-timeout",
                           u'max': 300,
                           u'min': 1,
                           u'type': u'range',
                           u'unit': u'1/10 seconds',
                           u'unit_prefix': u'1'}],
    u'drbd-proxy-lzma': [   {   u'default': 32768,
                                u'drbd_option_name': u'dict-size',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/dict-size",
                                u'max': 1610612736,
                                u'min': 4096,
                                u'type': u'range'},
                            {   u'default': 3,
                                u'drbd_option_name': u'lc',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/lc",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 0,
                                u'drbd_option_name': u'lp',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/lp",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 2,
                                u'drbd_option_name': u'pb',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/pb",
                                u'max': 4,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 273,
                                u'drbd_option_name': u'nice-len',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/nice-len",
                                u'max': 273,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': u'hc3',
                                u'drbd_option_name': u'mf',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/mf",
                                u'type': u'symbol',
                                u'values': [   u'hc4',
                                               u'hc3',
                                               u'bt2',
                                               u'bt3',
                                               u'bt4']},
                            {   u'default': u'fast',
                                u'drbd_option_name': u'mode',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/mode",
                                u'type': u'symbol',
                                u'values': [u'fast', u'normal']},
                            {   u'default': 0,
                                u'drbd_option_name': u'depth',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/depth",
                                u'max': 1000,
                                u'min': 0,
                                u'type': u'range'},
                            {   u'default': 4,
                                u'drbd_option_name': u'level',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/level",
                                u'max': 9,
                                u'min': 1,
                                u'type': u'range'},
                            {   u'default': u'thread count',
                                u'drbd_option_name': u'contexts',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/contexts",
                                u'max': 253,
                                u'min': 1,
                                u'type': u'range'},
                            {   u'default': u'off',
                                u'drbd_option_name': u'fallback-to-zlib',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/fallback-to-zlib",
                                u'type': u'symbol',
                                u'values': [u'off', u'on']},
                            {   u'default': 0,
                                u'drbd_option_name': u'numa-threshold',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/numa-threshold",
                                u'max': 253,
                                u'min': 0,
                                u'type': u'range'}],
    u'drbd-proxy-zlib': [   {   u'default': 2,
                                u'drbd_option_name': u'level',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/level",
                                u'max': 9,
                                u'min': 1,
                                u'type': u'range'}],
    u'drbd-proxy-zstd': [   {   u'default': 3,
                                u'drbd_option_name': u'level',
                                u'internal': True,
                                u'key': "DrbdOptions/ProxyCompression/level",
                                u'max': 22,
                                u'min': 1,
                                u'type': u'range'}],
    u'node': [   {   u'info': u'Preferred network interface to use',
                     u'key': consts.KEY_STOR_POOL_PREF_NIC,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'info': u'Linstor storage pool name to use.',
                     u'key': consts.KEY_STOR_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'info': u'Linstor storage pool name to use for external metadata.',
                     u'key': consts.KEY_STOR_POOL_DRBD_META_NAME,
                     u'type': u'regex',
                     u'value': u'^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                     u'internal': False,
                     u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                     u'type': u'long'},
                 {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                     u'internal': False,
                     u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                     u'type': u'long'},
                 {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                     u'internal': False,
                     u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                     u'type': u'long'},
                 {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                     u'internal': False,
                     u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                     u'type': u'long'},
                 {   u'default': 60,
                     u'info': u'Time a node can be offline before it is declared EVICTED in minutes',
                     u'internal': False,
                     u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_AFTER_TIME,
                     u'type': u'long'},
                 {   u'default': u'true',
                     u'info': u'If set to false on a node, it cannot be evicted anymore',
                     u'internal': False,
                     u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_ALLOW_EVICTION,
                     u'type': u'boolean_true_false'},
                 {   u'info': u'Linstor storage pool name for writecache',
                     u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'info': u'Size of the writecache in % (0-100) or KiB otherwise',
                     u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_SIZE,
                     u'type': u'regex',
                     u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                 {   u'default': u'0',
                     u'info': u'offset from the start of cache device in 512-byte sectors',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_START_SECTOR,
                     u'type': u'long'},
                 {   u'default': u'50',
                     u'info': u'start writeback when the number of used blocks reach this watermark',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_HIGH_WATERMARK,
                     u'type': u'long'},
                 {   u'default': u'45',
                     u'info': u'stop writeback when the number of used blocks drops below this watermark',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_LOW_WATERMARK,
                     u'type': u'long'},
                 {   u'default': u'unlimited',
                     u'info': u'limit the number of blocks that are in flight during writeback. Setting this value reduces writeback throughput, but it may improve latency of read requests',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_WRITEBACK_JOBS,
                     u'type': u'long'},
                 {   u'default': u'64 for pmem, 65536 for ssd',
                     u'info': u'when the application writes this amount of blocks without issuing the FLUSH request, the blocks are automatically committed',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_BLOCKS,
                     u'type': u'long'},
                 {   u'default': u'1000',
                     u'info': u'autocommit time in milliseconds. The data is automatically committed if this time passes and no FLUSH request is received',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_TIME,
                     u'type': u'long'},
                 {   u'default': u'On',
                     u'info': u'"On" results in "fua" as argument, whereas the value "Off" results in "nofua" argument',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_FUA,
                     u'type': u'symbol',
                     u'values': [u'On', u'Off']},
                 {   u'info': u'Additional arguments passed through',
                     u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_ADDITIONAL,
                     u'type': u'string'},
                 {   u'default': u'writethrough',
                     u'info': u'Operation mode',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_OPERATING_MODE,
                     u'type': u'symbol',
                     u'values': [   u'writeback',
                                    u'writethrough',
                                    u'passthrough']},
                 {   u'info': u'Name of the storage pool used for the cache metadata. If not specified, this will default to the CachePool property',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'default': u'12288',
                     u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_SIZE,
                     u'type': u'regex',
                     u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                 {   u'info': u'Name of the storage pool used for the cache cache device',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'default': u'5%',
                     u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_SIZE,
                     u'type': u'regex',
                     u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                 {   u'default': u'4096',
                     u'info': u'Block size',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_BLOCK_SIZE,
                     u'type': u'long'},
                 {   u'default': u'smq',
                     u'info': u'Replacement policy',
                     u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_POLICY,
                     u'type': u'symbol',
                     u'values': [u'mq', u'smq', u'cleaner']},
                 {   u'info': u'Name of the storage pool used for the bcache',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_POOL_NAME,
                     u'type': u'regex',
                     u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                 {   u'default': u'5%',
                     u'info': u'Size of the cache in % (0-100) or KiB otherwise. Minimum 524288',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_SIZE,
                     u'type': u'regex',
                     u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                 {   u'info': u'Block size',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BLOCKSIZE,
                     u'type': u'long'},
                 {   u'info': u'Bucket size',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BUCKETSIZE,
                     u'type': u'long'},
                 {   u'info': u'Data offset',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DATA_OFFSET,
                     u'type': u'long'},
                 {   u'info': u'Enable writeback if set to true',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_WRITEBACK,
                     u'type': u'boolean_true_false'},
                 {   u'info': u'Enable discard if set to true',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DISCARD,
                     u'type': u'boolean_true_false'},
                 {   u'info': u'Cache replacement policy. Default: lru',
                     u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_CACHE_REPLACEMENT_POLICY,
                     u'type': u'symbol',
                     u'values': [u'lru', u'fifo']},
                 {   u'info': u"Additional parameters added to every 'lvcreate ... ' command",
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_OPTIONS,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'info': u"Additional parameters added to every 'lvcreate --snapshot ... ' command",
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_SNAPSHOT_OPTIONS,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'info': u"Additional parameters added to every 'zfs create ... ' command",
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_CREATE_OPTIONS,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'info': u"Additional parameters added to every 'zfs snapshot ... ' command",
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_SNAPSHOT_OPTIONS,
                     u'type': u'regex',
                     u'value': u'.*'},
                 {   u'info': u'Remote SPDK API host name',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_HOST,
                     u'type': u'regex',
                     u'value': u'.+'},
                 {   u'info': u'Remote SPDK API port',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_PORT,
                     u'type': u'regex',
                     u'value': u'[0-9]+'},
                 {   u'info': u'Remote SPDK API user name',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME,
                     u'type': u'regex',
                     u'value': u'.+'},
                 {   u'info': u'Environment variable containing remote SPDK API user name',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME_ENV,
                     u'type': u'regex',
                     u'value': u'.+'},
                 {   u'info': u'Remote SPDK API password',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW,
                     u'type': u'regex',
                     u'value': u'.+'},
                 {   u'info': u'Environment variable containing remote SPDK API password',
                     u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW_ENV,
                     u'type': u'regex',
                     u'value': u'.+'},
                 {   u'info': u'linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)',
                     u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_VLM_TYPE,
                     u'type': u'symbol',
                     u'values': [u'linear', u'virtual']},
                 {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                     u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                     u'type': u'string'},
                 {   u'info': u'The maximum throughput the given storage pool is capable of.',
                     u'key': consts.NAMESPC_AUTOPLACER + '/' + consts.KEY_AUTOPLACE_MAX_THROUGHPUT,
                     u'type': u'long'},
                 {   u'info': u'Specifies if the storagepool(s) of the given node can be targeted by the autoplacer',
                     u'key': consts.KEY_AUTOPLACE_ALLOW_TARGET,
                     u'type': u'boolean_true_false'},
                 {   u'default': u'false',
                     u'internal': True,
                     u'key': consts.NAMESPC_DRBD_PROXY + '/' + consts.KEY_DRBD_PROXY_AUTO_ENABLE,
                     u'type': u'boolean_true_false'},
                 {   u'internal': True,
                     u'key': consts.KEY_SITE,
                     u'type': u'string'},
                 {   u'info': u'Allows this resource to be cleaned up after toggle-disk + resync is finished',
                     u'internal': False,
                     u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL_ALLOW_CLEANUP,
                     u'type': u'boolean_true_false'},
                 {   u'info': u"Appends '--skip-disk' to 'drbdadm adjust' commands. Is automatically set if a disk failure is detected. In order to disable, remove this property",
                     u'internal': False,
                     u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_SKIP_DISK,
                     u'type': u'symbol',
                     u'values': [u'True']},
                 {   u'default': u'gp2',
                     u'info': u'Sets the Volume Type for the EBS device (like gp2, gp3, etc..)',
                     u'key': consts.KEY_EBS_VOLUME_TYPE,
                     u'type': u'string'},
                 {   u'default': u'-1',
                     u'info': u'The maximum number of backups that can be shipped at the same time per node, negative means no limit',
                     u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_MAX_CONCURRENT_BACKUPS_PER_NODE,
                     u'type': u'long'}],
    u'node-conn': [   {   u'default': 100,
                          u'drbd_option_name': u'c-fill-target',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/c-fill-target",
                          u'max': 1048576,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes',
                          u'unit_prefix': u's'},
                      {   u'default': 102400,
                          u'drbd_option_name': u'c-max-rate',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/c-max-rate",
                          u'max': 4194304,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes/second',
                          u'unit_prefix': u'k'},
                      {   u'default': 250,
                          u'drbd_option_name': u'resync-rate',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/resync-rate",
                          u'max': 8388608,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'bytes/second',
                          u'unit_prefix': u'k'},
                      {   u'default': 10,
                          u'drbd_option_name': u'c-delay-target',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/c-delay-target",
                          u'max': 100,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'1/10 seconds',
                          u'unit_prefix': u'1'},
                      {   u'default': 250,
                          u'drbd_option_name': u'c-min-rate',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/c-min-rate",
                          u'max': 4194304,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes/second',
                          u'unit_prefix': u'k'},
                      {   u'default': True,
                          u'drbd_option_name': u'bitmap',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/bitmap",
                          u'type': u'boolean'},
                      {   u'default': 20,
                          u'drbd_option_name': u'c-plan-ahead',
                          u'drbd_res_file_section': u'disk',
                          u'internal': True,
                          u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                          u'max': 300,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'1/10 seconds',
                          u'unit_prefix': u'1'},
                      {   u'default': False,
                          u'drbd_option_name': u'load-balance-paths',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/load-balance-paths",
                          u'type': u'boolean'},
                      {   u'drbd_option_name': u'protocol',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/protocol",
                          u'type': u'symbol',
                          u'values': [u'A', u'B', u'C']},
                      {   u'default': 2048,
                          u'drbd_option_name': u'max-epoch-size',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/max-epoch-size",
                          u'max': 20000,
                          u'min': 1,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'default': False,
                          u'drbd_option_name': u'allow-two-primaries',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/allow-two-primaries",
                          u'type': u'boolean'},
                      {   u'drbd_option_name': u'after-sb-0pri',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/after-sb-0pri",
                          u'type': u'symbol',
                          u'values': [   u'disconnect',
                                         u'discard-younger-primary',
                                         u'discard-older-primary',
                                         u'discard-zero-changes',
                                         u'discard-least-changes',
                                         u'discard-local',
                                         u'discard-remote']},
                      {   u'default': 7,
                          u'drbd_option_name': u'ko-count',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/ko-count",
                          u'max': 200,
                          u'min': 0,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'data-integrity-alg',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/data-integrity-alg",
                          u'type': u'string'},
                      {   u'default': 5,
                          u'drbd_option_name': u'ping-timeout',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/ping-timeout",
                          u'max': 300,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'1/10 seconds',
                          u'unit_prefix': u'1'},
                      {   u'default': 0,
                          u'drbd_option_name': u'sndbuf-size',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/sndbuf-size",
                          u'max': 10485760,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'transport',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/transport",
                          u'type': u'string'},
                      {   u'default': 0,
                          u'drbd_option_name': u'rdma-ctrl-sndbuf-size',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/rdma-ctrl-sndbuf-size",
                          u'max': 10485760,
                          u'min': 0,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'tls-keyring',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/tls-keyring",
                          u'type': u'string'},
                      {   u'default': 0,
                          u'drbd_option_name': u'rcvbuf-size',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/rcvbuf-size",
                          u'max': 10485760,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes',
                          u'unit_prefix': u'1'},
                      {   u'default': 2048,
                          u'drbd_option_name': u'max-buffers',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/max-buffers",
                          u'max': 131072,
                          u'min': 32,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'fencing',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/fencing",
                          u'type': u'symbol',
                          u'values': [   u'dont-care',
                                         u'resource-only',
                                         u'resource-and-stonith']},
                      {   u'drbd_option_name': u'csums-alg',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/csums-alg",
                          u'type': u'string'},
                      {   u'default': False,
                          u'drbd_option_name': u'always-asbp',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/always-asbp",
                          u'type': u'boolean'},
                      {   u'drbd_option_name': u'tls-privkey',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/tls-privkey",
                          u'type': u'string'},
                      {   u'default': 1237,
                          u'drbd_option_name': u'congestion-extents',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/congestion-extents",
                          u'max': 65534,
                          u'min': 67,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'on-congestion',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/on-congestion",
                          u'type': u'symbol',
                          u'values': [   u'block',
                                         u'pull-ahead',
                                         u'disconnect']},
                      {   u'default': 0,
                          u'drbd_option_name': u'rdma-ctrl-rcvbuf-size',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/rdma-ctrl-rcvbuf-size",
                          u'max': 10485760,
                          u'min': 0,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'default': 10,
                          u'drbd_option_name': u'ping-int',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/ping-int",
                          u'max': 120,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'seconds',
                          u'unit_prefix': u'1'},
                      {   u'default': False,
                          u'drbd_option_name': u'tls',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/tls",
                          u'type': u'boolean'},
                      {   u'drbd_option_name': u'rr-conflict',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/rr-conflict",
                          u'type': u'symbol',
                          u'values': [   u'disconnect',
                                         u'call-pri-lost',
                                         u'violently',
                                         u'retry-connect',
                                         u'auto-discard']},
                      {   u'default': True,
                          u'drbd_option_name': u'tcp-cork',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/tcp-cork",
                          u'type': u'boolean'},
                      {   u'default': True,
                          u'drbd_option_name': u'use-rle',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/use-rle",
                          u'type': u'boolean'},
                      {   u'default': False,
                          u'drbd_option_name': u'csums-after-crash-only',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/csums-after-crash-only",
                          u'type': u'boolean'},
                      {   u'default': 0,
                          u'drbd_option_name': u'socket-check-timeout',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/socket-check-timeout",
                          u'max': 300,
                          u'min': 0,
                          u'type': u'range',
                          u'unit_prefix': u'1'},
                      {   u'default': 0,
                          u'drbd_option_name': u'congestion-fill',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/congestion-fill",
                          u'max': 20971520,
                          u'min': 0,
                          u'type': u'range',
                          u'unit': u'bytes',
                          u'unit_prefix': u's'},
                      {   u'drbd_option_name': u'cram-hmac-alg',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/cram-hmac-alg",
                          u'type': u'string'},
                      {   u'drbd_option_name': u'verify-alg',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/verify-alg",
                          u'type': u'string'},
                      {   u'default': True,
                          u'drbd_option_name': u'allow-remote-read',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/allow-remote-read",
                          u'type': u'boolean'},
                      {   u'drbd_option_name': u'shared-secret',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/shared-secret",
                          u'type': u'string'},
                      {   u'default': 10,
                          u'drbd_option_name': u'connect-int',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/connect-int",
                          u'max': 120,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'seconds',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'tls-certificate',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/tls-certificate",
                          u'type': u'string'},
                      {   u'default': 60,
                          u'drbd_option_name': u'timeout',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/timeout",
                          u'max': 600,
                          u'min': 1,
                          u'type': u'range',
                          u'unit': u'1/10 seconds',
                          u'unit_prefix': u'1'},
                      {   u'drbd_option_name': u'after-sb-2pri',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/after-sb-2pri",
                          u'type': u'symbol',
                          u'values': [   u'disconnect',
                                         u'call-pri-lost-after-sb',
                                         u'violently-as0p']},
                      {   u'drbd_option_name': u'after-sb-1pri',
                          u'drbd_res_file_section': u'net',
                          u'internal': True,
                          u'key': "DrbdOptions/Net/after-sb-1pri",
                          u'type': u'symbol',
                          u'values': [   u'disconnect',
                                         u'consensus',
                                         u'discard-secondary',
                                         u'call-pri-lost-after-sb',
                                         u'violently-as0p']}],
    u'resource': [   {   u'info': u'Linstor storage pool name to use.',
                         u'key': consts.KEY_STOR_POOL_NAME,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'Linstor storage pool name to use for external metadata.',
                         u'key': consts.KEY_STOR_POOL_DRBD_META_NAME,
                         u'type': u'regex',
                         u'value': u'^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'Preferred network interface to use',
                         u'key': consts.KEY_STOR_POOL_PREF_NIC,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'DRBD peer slots present on resource',
                         u'internal': True,
                         u'key': consts.KEY_PEER_SLOTS,
                         u'max': 31,
                         u'min': 1,
                         u'type': u'range'},
                     {   u'info': u'File system type to use',
                         u'internal': False,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                         u'type': u'symbol',
                         u'values': [u'ext4', u'xfs']},
                     {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only Group is given, use 'nobody' as user",
                         u'info': u'Owner user (name or ID) of the created file system',
                         u'internal': False,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_USER,
                         u'type': u'string'},
                     {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only User is given, use the user's group",
                         u'info': u'Owner group (name or ID) of the created file system',
                         u'internal': False,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_GROUP,
                         u'type': u'string'},
                     {   u'info': u'Additional parameters for the mkfs command',
                         u'internal': False,
                         u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                         u'type': u'string'},
                     {   u'info': u'Preferred network interface to use',
                         u'internal': False,
                         u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PREF_NIC,
                         u'type': u'regex',
                         u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                     {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                         u'internal': False,
                         u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                         u'type': u'long'},
                     {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                         u'internal': False,
                         u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                         u'type': u'long'},
                     {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                         u'internal': False,
                         u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                         u'type': u'long'},
                     {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                         u'internal': False,
                         u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                         u'type': u'long'},
                     {   u'info': u'Allows this resource to be cleaned up after toggle-disk + resync is finished',
                         u'internal': False,
                         u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL_ALLOW_CLEANUP,
                         u'type': u'boolean_true_false'},
                     {   u'info': u"Appends '--skip-disk' to 'drbdadm adjust' commands. Is automatically set if a disk failure is detected. In order to disable, remove this property",
                         u'internal': False,
                         u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_SKIP_DISK,
                         u'type': u'symbol',
                         u'values': [u'True']},
                     {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                         u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                         u'type': u'string'}],
    u'resource-definition': [   {   u'info': u'Linstor storage pool name to use.',
                                    u'key': consts.KEY_STOR_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'info': u'Linstor storage pool name to use for external metadata.',
                                    u'key': consts.KEY_STOR_POOL_DRBD_META_NAME,
                                    u'type': u'regex',
                                    u'value': u'^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'info': u'DRBD peer slots to allocate for newly created resources (default 7), the number of peer slots cannot be changed once the resource is created, so allow sufficient slots to increase redundancy in the future',
                                    u'key': consts.KEY_PEER_SLOTS_NEW_RESOURCE,
                                    u'max': 31,
                                    u'min': 1,
                                    u'type': u'range'},
                                {   u'internal': True,
                                    u'key': consts.NAMESPC_DRBD_PROXY + '/' + consts.KEY_DRBD_PROXY_COMPRESSION_TYPE,
                                    u'type': u'symbol',
                                    u'values': [   u'zlib',
                                                   u'lzma',
                                                   u'lz4',
                                                   u'zstd']},
                                {   u'default': u'The place count set for the resource group',
                                    u'info': u'The minimum amount of replicas that should be present for a resource at all times.',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_AUTO_EVICT_MIN_REPLICA_COUNT,
                                    u'type': u'long'},
                                {   u'info': u'File system type to use',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'ext4', u'xfs']},
                                {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only Group is given, use 'nobody' as user",
                                    u'info': u'Owner user (name or ID) of the created file system',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_USER,
                                    u'type': u'string'},
                                {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only User is given, use the user's group",
                                    u'info': u'Owner group (name or ID) of the created file system',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_GROUP,
                                    u'type': u'string'},
                                {   u'info': u'Additional parameters for the mkfs command',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                                    u'type': u'string'},
                                {   u'default': u'rdma',
                                    u'info': u'NVMe transportation type',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_NVME + '/' + consts.KEY_TR_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'rdma', u'tcp']},
                                {   u'info': u'NVMe port',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PORT,
                                    u'max': 65535,
                                    u'min': 1,
                                    u'type': u'range'},
                                {   u'default': u'linear',
                                    u'internal': True,
                                    u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_TYPE,
                                    u'type': u'symbol',
                                    u'values': [   u'linear',
                                                   u'striped',
                                                   u'mirror',
                                                   u'raid0',
                                                   u'raid1',
                                                   u'raid4',
                                                   u'raid5',
                                                   u'raid6',
                                                   u'raid10',
                                                   u'lzma',
                                                   u'lz4']},
                                {   u'info': u"Additional parameters added to every 'lvcreate ... ' command",
                                    u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_OPTIONS,
                                    u'type': u'regex',
                                    u'value': u'.*'},
                                {   u'info': u"Additional parameters added to every 'lvcreate --snapshot ... ' command",
                                    u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_SNAPSHOT_OPTIONS,
                                    u'type': u'regex',
                                    u'value': u'.*'},
                                {   u'info': u"Additional parameters added to every 'zfs create ... ' command",
                                    u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_CREATE_OPTIONS,
                                    u'type': u'regex',
                                    u'value': u'.*'},
                                {   u'info': u"Additional parameters added to every 'zfs snapshot ... ' command",
                                    u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_SNAPSHOT_OPTIONS,
                                    u'type': u'regex',
                                    u'value': u'.*'},
                                {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                                    u'type': u'long'},
                                {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                                    u'type': u'long'},
                                {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                                    u'type': u'long'},
                                {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                                    u'type': u'long'},
                                {   u'info': u"Enables automatic setting of the 'quorum' and 'on-no-quorum' property",
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_QUORUM,
                                    u'type': u'symbol',
                                    u'values': [   u'io-error',
                                                   u'suspend-io',
                                                   u'disabled']},
                                {   u'info': u'Enables automatic management (creation and deletion) of tie breaking resource',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_ADD_QUORUM_TIEBREAKER,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u'Makes a resource diskful if it was continuously diskless primary for X minutes',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL,
                                    u'type': u'long'},
                                {   u'info': u'Allows this resource to be cleaned up after toggle-disk + resync is finished',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_DISKFUL_ALLOW_CLEANUP,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u'If set to true it will disable automatic setting of DRBD verify algorithm',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_DISABLE_AUTO_VERIFY_ALGO,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u"Appends '--skip-disk' to 'drbdadm adjust' commands. Is automatically set if a disk failure is detected. In order to disable, remove this property",
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_SKIP_DISK,
                                    u'type': u'symbol',
                                    u'values': [u'True']},
                                {   u'info': u'Linstor storage pool name for writecache',
                                    u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'info': u'Size of the writecache in % (0-100) or KiB otherwise',
                                    u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_SIZE,
                                    u'type': u'regex',
                                    u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                                {   u'default': u'0',
                                    u'info': u'offset from the start of cache device in 512-byte sectors',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_START_SECTOR,
                                    u'type': u'long'},
                                {   u'default': u'50',
                                    u'info': u'start writeback when the number of used blocks reach this watermark',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_HIGH_WATERMARK,
                                    u'type': u'long'},
                                {   u'default': u'45',
                                    u'info': u'stop writeback when the number of used blocks drops below this watermark',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_LOW_WATERMARK,
                                    u'type': u'long'},
                                {   u'default': u'unlimited',
                                    u'info': u'limit the number of blocks that are in flight during writeback. Setting this value reduces writeback throughput, but it may improve latency of read requests',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_WRITEBACK_JOBS,
                                    u'type': u'long'},
                                {   u'default': u'64 for pmem, 65536 for ssd',
                                    u'info': u'when the application writes this amount of blocks without issuing the FLUSH request, the blocks are automatically committed',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_BLOCKS,
                                    u'type': u'long'},
                                {   u'default': u'1000',
                                    u'info': u'autocommit time in milliseconds. The data is automatically committed if this time passes and no FLUSH request is received',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_TIME,
                                    u'type': u'long'},
                                {   u'default': u'On',
                                    u'info': u'"On" results in "fua" as argument, whereas the value "Off" results in "nofua" argument',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_FUA,
                                    u'type': u'symbol',
                                    u'values': [u'On', u'Off']},
                                {   u'info': u'Additional arguments passed through',
                                    u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_ADDITIONAL,
                                    u'type': u'string'},
                                {   u'default': u'writethrough',
                                    u'info': u'Operation mode',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_OPERATING_MODE,
                                    u'type': u'symbol',
                                    u'values': [   u'writeback',
                                                   u'writethrough',
                                                   u'passthrough']},
                                {   u'info': u'Name of the storage pool used for the cache metadata. If not specified, this will default to the CachePool property',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'default': u'12288',
                                    u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_SIZE,
                                    u'type': u'regex',
                                    u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                                {   u'info': u'Name of the storage pool used for the cache cache device',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'default': u'5%',
                                    u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_SIZE,
                                    u'type': u'regex',
                                    u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                                {   u'default': u'4096',
                                    u'info': u'Block size',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_BLOCK_SIZE,
                                    u'type': u'long'},
                                {   u'default': u'smq',
                                    u'info': u'Replacement policy',
                                    u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_POLICY,
                                    u'type': u'symbol',
                                    u'values': [u'mq', u'smq', u'cleaner']},
                                {   u'info': u'Name of the storage pool used for the bcache',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_POOL_NAME,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'default': u'5%',
                                    u'info': u'Size of the cache in % (0-100) or KiB otherwise. Minimum 524288',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_SIZE,
                                    u'type': u'regex',
                                    u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                                {   u'info': u'Block size',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BLOCKSIZE,
                                    u'type': u'long'},
                                {   u'info': u'Bucket size',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BUCKETSIZE,
                                    u'type': u'long'},
                                {   u'info': u'Data offset',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DATA_OFFSET,
                                    u'type': u'long'},
                                {   u'info': u'Enable writeback if set to true',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_WRITEBACK,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u'Enable discard if set to true',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DISCARD,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u'Cache replacement policy. Default: lru',
                                    u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_CACHE_REPLACEMENT_POLICY,
                                    u'type': u'symbol',
                                    u'values': [u'lru', u'fifo']},
                                {   u'info': u'Node name of the snapshot shipping source',
                                    u'key': consts.NAMESPC_SNAPSHOT_SHIPPING + '/' + consts.KEY_SOURCE_NODE,
                                    u'type': u'string'},
                                {   u'info': u'Node name of the snapshot shipping target',
                                    u'key': consts.NAMESPC_SNAPSHOT_SHIPPING + '/' + consts.KEY_TARGET_NODE,
                                    u'type': u'string'},
                                {   u'info': u'Runs every X minutes an auto-snapshot-shipping unless the current snapshot-shipping is still running. In this case a new one will be started asap.',
                                    u'key': consts.NAMESPC_SNAPSHOT_SHIPPING + '/' + consts.KEY_RUN_EVERY,
                                    u'type': u'long'},
                                {   u'default': u'10',
                                    u'info': u'Keeps the last X shipped snapshots. Removing this property or having a value <= 0 disables auto-cleanup, all auto-snapshots will be kept',
                                    u'key': consts.NAMESPC_SNAPSHOT_SHIPPING + '/' + consts.KEY_KEEP,
                                    u'type': u'long'},
                                {   u'info': u'Runs every X minutes an snapshot-creation. Removing this property or having a value <= 0 disables auto-snapshotting.',
                                    u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_RUN_EVERY,
                                    u'type': u'long'},
                                {   u'default': u'10',
                                    u'info': u'Keeps the last X auto-snapshots. Removing this property or having a value <= 0 disables auto-cleanup, all auto-snapshots will be kept',
                                    u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_KEEP,
                                    u'type': u'long'},
                                {   u'info': u'The next ID to try for auto-snapshots',
                                    u'key': consts.NAMESPC_AUTO_SNAPSHOT + '/' + consts.KEY_AUTO_SNAPSHOT_NEXT_ID,
                                    u'type': u'long'},
                                {   u'info': u'linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)',
                                    u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_VLM_TYPE,
                                    u'type': u'symbol',
                                    u'values': [u'linear', u'virtual']},
                                {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                                    u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                                    u'type': u'string'},
                                {   u'info': u'Preferred network interface to use',
                                    u'key': consts.KEY_STOR_POOL_PREF_NIC,
                                    u'type': u'regex',
                                    u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                                {   u'default': u'false',
                                    u'info': u'if true: Zfs clone will use snapshot clone, instead of send/receive',
                                    u'key': consts.KEY_USE_ZFS_CLONE,
                                    u'type': u'boolean_true_false'},
                                {   u'default': u'false',
                                    u'info': u'Allow mixing storage pool drivers for migration purpose',
                                    u'key': consts.KEY_RSC_ALLOW_MIXING_DEVICE_KIND,
                                    u'type': u'boolean_true_false'},
                                {   u'default': u'gp2',
                                    u'info': u'Sets the Volume Type for the EBS device (like gp2, gp3, etc..)',
                                    u'key': consts.KEY_EBS_VOLUME_TYPE,
                                    u'type': u'string'},
                                {   u'default': u'false',
                                    u'info': u'Forces any thin volumes to do the initial sync. Any resources created while this is true will behave so permanently.',
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_FORCE_INITIAL_SYNC,
                                    u'type': u'boolean_true_false'},
                                {   u'info': u'If set to false it will disable automatic setting of DRBD rs-discard-granularity. If not set or set to true, automatically setting the rs-discard-granularity property might override previously values specified by the user on volume-definition level',
                                    u'internal': False,
                                    u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_RS_DISCARD_GRANULARITY,
                                    u'type': u'string'},
                                {   u'default': u'true',
                                    u'info': u'If set to false it will disable the balance resource task',
                                    u'internal': False,
                                    u'key': consts.KEY_BALANCE_RESOURCES_ENABLED,
                                    u'type': u'boolean_true_false'},
                                {   u'default': u'false',
                                    u'info': u'If true, an existing resource can be deleted in order to restore a received backup',
                                    u'key': consts.NAMESPC_BACKUP_SHIPPING + '/' + consts.KEY_ALLOW_FORCE_RESTORE,
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'read-balancing',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/read-balancing",
                                    u'type': u'symbol',
                                    u'values': [   u'prefer-local',
                                                   u'prefer-remote',
                                                   u'round-robin',
                                                   u'least-pending',
                                                   u'when-congested-remote',
                                                   u'32K-striping',
                                                   u'64K-striping',
                                                   u'128K-striping',
                                                   u'256K-striping',
                                                   u'512K-striping',
                                                   u'1M-striping']},
                                {   u'drbd_option_name': u'on-io-error',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/on-io-error",
                                    u'type': u'symbol',
                                    u'values': [   u'pass_on',
                                                   u'call-local-io-error',
                                                   u'detach']},
                                {   u'default': True,
                                    u'drbd_option_name': u'disk-drain',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-drain",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'resync-after',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/resync-after",
                                    u'type': u'string'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'disk-timeout',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-timeout",
                                    u'max': 6000,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': False,
                                    u'drbd_option_name': u'disable-write-same',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disable-write-same",
                                    u'type': u'boolean'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rs-discard-granularity',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/rs-discard-granularity",
                                    u'max': 1048576,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'default': True,
                                    u'drbd_option_name': u'disk-flushes',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-flushes",
                                    u'type': u'boolean'},
                                {   u'default': 1237,
                                    u'drbd_option_name': u'al-extents',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/al-extents",
                                    u'max': 65534,
                                    u'min': 67,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': True,
                                    u'drbd_option_name': u'al-updates',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/al-updates",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'md-flushes',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/md-flushes",
                                    u'type': u'boolean'},
                                {   u'default': False,
                                    u'drbd_option_name': u'disk-barrier',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/disk-barrier",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'discard-zeroes-if-aligned',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                                    u'type': u'boolean'},
                                {   u'default': 100,
                                    u'drbd_option_name': u'c-fill-target',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-fill-target",
                                    u'max': 1048576,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'default': 102400,
                                    u'drbd_option_name': u'c-max-rate',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-max-rate",
                                    u'max': 4194304,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': 250,
                                    u'drbd_option_name': u'resync-rate',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/resync-rate",
                                    u'max': 8388608,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': 10,
                                    u'drbd_option_name': u'c-delay-target',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-delay-target",
                                    u'max': 100,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 250,
                                    u'drbd_option_name': u'c-min-rate',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-min-rate",
                                    u'max': 4194304,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes/second',
                                    u'unit_prefix': u'k'},
                                {   u'default': True,
                                    u'drbd_option_name': u'bitmap',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/bitmap",
                                    u'type': u'boolean'},
                                {   u'default': 20,
                                    u'drbd_option_name': u'c-plan-ahead',
                                    u'drbd_res_file_section': u'disk',
                                    u'internal': True,
                                    u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                                    u'max': 300,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 100,
                                    u'drbd_option_name': u'peer-ack-delay',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/peer-ack-delay",
                                    u'max': 10000,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'milliseconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'quorum-minimum-redundancy',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/quorum-minimum-redundancy",
                                    u'max': u'32',
                                    u'min': u'1',
                                    u'type': u'numeric-or-symbol',
                                    u'values': [u'off', u'majority', u'all']},
                                {   u'default': 8000,
                                    u'drbd_option_name': u'max-io-depth',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/max-io-depth",
                                    u'max': 4294967295,
                                    u'min': 4,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': 20,
                                    u'drbd_option_name': u'auto-promote-timeout',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/auto-promote-timeout",
                                    u'max': 600,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'quorum',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/quorum",
                                    u'max': u'32',
                                    u'min': u'1',
                                    u'type': u'numeric-or-symbol',
                                    u'values': [u'off', u'majority', u'all']},
                                {   u'drbd_option_name': u'on-no-data-accessible',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/on-no-data-accessible",
                                    u'type': u'symbol',
                                    u'values': [u'io-error', u'suspend-io']},
                                {   u'default': True,
                                    u'drbd_option_name': u'auto-promote',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/auto-promote",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'cpu-mask',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/cpu-mask",
                                    u'type': u'string'},
                                {   u'default': 300,
                                    u'drbd_option_name': u'twopc-timeout',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/twopc-timeout",
                                    u'max': 600,
                                    u'min': 50,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 1,
                                    u'drbd_option_name': u'twopc-retry-timeout',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/twopc-retry-timeout",
                                    u'max': 50,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'on-suspended-primary-outdated',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/on-suspended-primary-outdated",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'force-secondary']},
                                {   u'default': 4096,
                                    u'drbd_option_name': u'peer-ack-window',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/peer-ack-window",
                                    u'max': 204800,
                                    u'min': 2048,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'drbd_option_name': u'on-no-quorum',
                                    u'drbd_res_file_section': u'options',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Resource/on-no-quorum",
                                    u'type': u'symbol',
                                    u'values': [u'io-error', u'suspend-io']},
                                {   u'default': False,
                                    u'drbd_option_name': u'load-balance-paths',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/load-balance-paths",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'protocol',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/protocol",
                                    u'type': u'symbol',
                                    u'values': [u'A', u'B', u'C']},
                                {   u'default': 2048,
                                    u'drbd_option_name': u'max-epoch-size',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/max-epoch-size",
                                    u'max': 20000,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': False,
                                    u'drbd_option_name': u'allow-two-primaries',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/allow-two-primaries",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'after-sb-0pri',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-0pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'discard-younger-primary',
                                                   u'discard-older-primary',
                                                   u'discard-zero-changes',
                                                   u'discard-least-changes',
                                                   u'discard-local',
                                                   u'discard-remote']},
                                {   u'default': 7,
                                    u'drbd_option_name': u'ko-count',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ko-count",
                                    u'max': 200,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'data-integrity-alg',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/data-integrity-alg",
                                    u'type': u'string'},
                                {   u'default': 5,
                                    u'drbd_option_name': u'ping-timeout',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ping-timeout",
                                    u'max': 300,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'sndbuf-size',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/sndbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'transport',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/transport",
                                    u'type': u'string'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rdma-ctrl-sndbuf-size',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rdma-ctrl-sndbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'tls-keyring',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tls-keyring",
                                    u'type': u'string'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rcvbuf-size',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rcvbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u'1'},
                                {   u'default': 2048,
                                    u'drbd_option_name': u'max-buffers',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/max-buffers",
                                    u'max': 131072,
                                    u'min': 32,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'fencing',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/fencing",
                                    u'type': u'symbol',
                                    u'values': [   u'dont-care',
                                                   u'resource-only',
                                                   u'resource-and-stonith']},
                                {   u'drbd_option_name': u'csums-alg',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/csums-alg",
                                    u'type': u'string'},
                                {   u'default': False,
                                    u'drbd_option_name': u'always-asbp',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/always-asbp",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'tls-privkey',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tls-privkey",
                                    u'type': u'string'},
                                {   u'default': 1237,
                                    u'drbd_option_name': u'congestion-extents',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/congestion-extents",
                                    u'max': 65534,
                                    u'min': 67,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'on-congestion',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/on-congestion",
                                    u'type': u'symbol',
                                    u'values': [   u'block',
                                                   u'pull-ahead',
                                                   u'disconnect']},
                                {   u'default': 0,
                                    u'drbd_option_name': u'rdma-ctrl-rcvbuf-size',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rdma-ctrl-rcvbuf-size",
                                    u'max': 10485760,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': 10,
                                    u'drbd_option_name': u'ping-int',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/ping-int",
                                    u'max': 120,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'seconds',
                                    u'unit_prefix': u'1'},
                                {   u'default': False,
                                    u'drbd_option_name': u'tls',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tls",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'rr-conflict',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/rr-conflict",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'call-pri-lost',
                                                   u'violently',
                                                   u'retry-connect',
                                                   u'auto-discard']},
                                {   u'default': True,
                                    u'drbd_option_name': u'tcp-cork',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tcp-cork",
                                    u'type': u'boolean'},
                                {   u'default': True,
                                    u'drbd_option_name': u'use-rle',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/use-rle",
                                    u'type': u'boolean'},
                                {   u'default': False,
                                    u'drbd_option_name': u'csums-after-crash-only',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/csums-after-crash-only",
                                    u'type': u'boolean'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'socket-check-timeout',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/socket-check-timeout",
                                    u'max': 300,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit_prefix': u'1'},
                                {   u'default': 0,
                                    u'drbd_option_name': u'congestion-fill',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/congestion-fill",
                                    u'max': 20971520,
                                    u'min': 0,
                                    u'type': u'range',
                                    u'unit': u'bytes',
                                    u'unit_prefix': u's'},
                                {   u'drbd_option_name': u'cram-hmac-alg',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/cram-hmac-alg",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'verify-alg',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/verify-alg",
                                    u'type': u'string'},
                                {   u'default': True,
                                    u'drbd_option_name': u'allow-remote-read',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/allow-remote-read",
                                    u'type': u'boolean'},
                                {   u'drbd_option_name': u'shared-secret',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/shared-secret",
                                    u'type': u'string'},
                                {   u'default': 10,
                                    u'drbd_option_name': u'connect-int',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/connect-int",
                                    u'max': 120,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'tls-certificate',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/tls-certificate",
                                    u'type': u'string'},
                                {   u'default': 60,
                                    u'drbd_option_name': u'timeout',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/timeout",
                                    u'max': 600,
                                    u'min': 1,
                                    u'type': u'range',
                                    u'unit': u'1/10 seconds',
                                    u'unit_prefix': u'1'},
                                {   u'drbd_option_name': u'after-sb-2pri',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-2pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'call-pri-lost-after-sb',
                                                   u'violently-as0p']},
                                {   u'drbd_option_name': u'after-sb-1pri',
                                    u'drbd_res_file_section': u'net',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Net/after-sb-1pri",
                                    u'type': u'symbol',
                                    u'values': [   u'disconnect',
                                                   u'consensus',
                                                   u'discard-secondary',
                                                   u'call-pri-lost-after-sb',
                                                   u'violently-as0p']},
                                {   u'drbd_option_name': u'after-resync-target',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/after-resync-target",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'before-resync-target',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/before-resync-target",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'before-resync-source',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/before-resync-source",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'out-of-sync',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/out-of-sync",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'quorum-lost',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/quorum-lost",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'fence-peer',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/fence-peer",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'unfence-peer',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/unfence-peer",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'initial-split-brain',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/initial-split-brain",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'local-io-error',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/local-io-error",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-lost',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-lost",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-lost-after-sb',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-lost-after-sb",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'pri-on-incon-degr',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/pri-on-incon-degr",
                                    u'type': u'string'},
                                {   u'drbd_option_name': u'split-brain',
                                    u'drbd_res_file_section': u'handlers',
                                    u'internal': True,
                                    u'key': "DrbdOptions/Handlers/split-brain",
                                    u'type': u'string'}],
    u'rsc-conn': [   {   u'default': 100,
                         u'drbd_option_name': u'c-fill-target',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-fill-target",
                         u'max': 1048576,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u's'},
                     {   u'default': 102400,
                         u'drbd_option_name': u'c-max-rate',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-max-rate",
                         u'max': 4194304,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': 250,
                         u'drbd_option_name': u'resync-rate',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/resync-rate",
                         u'max': 8388608,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': 10,
                         u'drbd_option_name': u'c-delay-target',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-delay-target",
                         u'max': 100,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 250,
                         u'drbd_option_name': u'c-min-rate',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-min-rate",
                         u'max': 4194304,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes/second',
                         u'unit_prefix': u'k'},
                     {   u'default': True,
                         u'drbd_option_name': u'bitmap',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/bitmap",
                         u'type': u'boolean'},
                     {   u'default': 20,
                         u'drbd_option_name': u'c-plan-ahead',
                         u'drbd_res_file_section': u'disk',
                         u'internal': True,
                         u'key': "DrbdOptions/PeerDevice/c-plan-ahead",
                         u'max': 300,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': False,
                         u'drbd_option_name': u'load-balance-paths',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/load-balance-paths",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'protocol',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/protocol",
                         u'type': u'symbol',
                         u'values': [u'A', u'B', u'C']},
                     {   u'default': 2048,
                         u'drbd_option_name': u'max-epoch-size',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/max-epoch-size",
                         u'max': 20000,
                         u'min': 1,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'default': False,
                         u'drbd_option_name': u'allow-two-primaries',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/allow-two-primaries",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'after-sb-0pri',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-0pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'discard-younger-primary',
                                        u'discard-older-primary',
                                        u'discard-zero-changes',
                                        u'discard-least-changes',
                                        u'discard-local',
                                        u'discard-remote']},
                     {   u'default': 7,
                         u'drbd_option_name': u'ko-count',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ko-count",
                         u'max': 200,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'data-integrity-alg',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/data-integrity-alg",
                         u'type': u'string'},
                     {   u'default': 5,
                         u'drbd_option_name': u'ping-timeout',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ping-timeout",
                         u'max': 300,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': 0,
                         u'drbd_option_name': u'sndbuf-size',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/sndbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'transport',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/transport",
                         u'type': u'string'},
                     {   u'default': 0,
                         u'drbd_option_name': u'rdma-ctrl-sndbuf-size',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rdma-ctrl-sndbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'tls-keyring',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tls-keyring",
                         u'type': u'string'},
                     {   u'default': 0,
                         u'drbd_option_name': u'rcvbuf-size',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rcvbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u'1'},
                     {   u'default': 2048,
                         u'drbd_option_name': u'max-buffers',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/max-buffers",
                         u'max': 131072,
                         u'min': 32,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'fencing',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/fencing",
                         u'type': u'symbol',
                         u'values': [   u'dont-care',
                                        u'resource-only',
                                        u'resource-and-stonith']},
                     {   u'drbd_option_name': u'csums-alg',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/csums-alg",
                         u'type': u'string'},
                     {   u'default': False,
                         u'drbd_option_name': u'always-asbp',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/always-asbp",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'tls-privkey',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tls-privkey",
                         u'type': u'string'},
                     {   u'default': 1237,
                         u'drbd_option_name': u'congestion-extents',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/congestion-extents",
                         u'max': 65534,
                         u'min': 67,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'on-congestion',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/on-congestion",
                         u'type': u'symbol',
                         u'values': [u'block', u'pull-ahead', u'disconnect']},
                     {   u'default': 0,
                         u'drbd_option_name': u'rdma-ctrl-rcvbuf-size',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rdma-ctrl-rcvbuf-size",
                         u'max': 10485760,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'default': 10,
                         u'drbd_option_name': u'ping-int',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/ping-int",
                         u'max': 120,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'seconds',
                         u'unit_prefix': u'1'},
                     {   u'default': False,
                         u'drbd_option_name': u'tls',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tls",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'rr-conflict',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/rr-conflict",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'call-pri-lost',
                                        u'violently',
                                        u'retry-connect',
                                        u'auto-discard']},
                     {   u'default': True,
                         u'drbd_option_name': u'tcp-cork',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tcp-cork",
                         u'type': u'boolean'},
                     {   u'default': True,
                         u'drbd_option_name': u'use-rle',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/use-rle",
                         u'type': u'boolean'},
                     {   u'default': False,
                         u'drbd_option_name': u'csums-after-crash-only',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/csums-after-crash-only",
                         u'type': u'boolean'},
                     {   u'default': 0,
                         u'drbd_option_name': u'socket-check-timeout',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/socket-check-timeout",
                         u'max': 300,
                         u'min': 0,
                         u'type': u'range',
                         u'unit_prefix': u'1'},
                     {   u'default': 0,
                         u'drbd_option_name': u'congestion-fill',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/congestion-fill",
                         u'max': 20971520,
                         u'min': 0,
                         u'type': u'range',
                         u'unit': u'bytes',
                         u'unit_prefix': u's'},
                     {   u'drbd_option_name': u'cram-hmac-alg',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/cram-hmac-alg",
                         u'type': u'string'},
                     {   u'drbd_option_name': u'verify-alg',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/verify-alg",
                         u'type': u'string'},
                     {   u'default': True,
                         u'drbd_option_name': u'allow-remote-read',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/allow-remote-read",
                         u'type': u'boolean'},
                     {   u'drbd_option_name': u'shared-secret',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/shared-secret",
                         u'type': u'string'},
                     {   u'default': 10,
                         u'drbd_option_name': u'connect-int',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/connect-int",
                         u'max': 120,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'seconds',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'tls-certificate',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/tls-certificate",
                         u'type': u'string'},
                     {   u'default': 60,
                         u'drbd_option_name': u'timeout',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/timeout",
                         u'max': 600,
                         u'min': 1,
                         u'type': u'range',
                         u'unit': u'1/10 seconds',
                         u'unit_prefix': u'1'},
                     {   u'drbd_option_name': u'after-sb-2pri',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-2pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'call-pri-lost-after-sb',
                                        u'violently-as0p']},
                     {   u'drbd_option_name': u'after-sb-1pri',
                         u'drbd_res_file_section': u'net',
                         u'internal': True,
                         u'key': "DrbdOptions/Net/after-sb-1pri",
                         u'type': u'symbol',
                         u'values': [   u'disconnect',
                                        u'consensus',
                                        u'discard-secondary',
                                        u'call-pri-lost-after-sb',
                                        u'violently-as0p']}],
    u'storagepool': [   {   u'info': u'Default value for MaxFreeCapacityOversubscriptionRatio and MaxTotalCapacityOversubscriptionRatio (default 20)',
                            u'key': consts.KEY_STOR_POOL_MAX_OVERSUBSCRIPTION_RATIO,
                            u'max_float': 1000.0,
                            u'min_float': 0.0,
                            u'type': u'range-float'},
                        {   u'info': u'Maximum allowed ratio the remaining free space can be overprovisioned (default 20)',
                            u'key': consts.KEY_STOR_POOL_MAX_FREE_CAPACITY_OVERSUBSCRIPTION_RATIO,
                            u'max_float': 1000.0,
                            u'min_float': 0.0,
                            u'type': u'range-float'},
                        {   u'info': u'Maximum allowed ratio the capacity can be overprovisioned (default 20)',
                            u'key': consts.KEY_STOR_POOL_MAX_TOTAL_CAPACITY_OVERSUBSCRIPTION_RATIO,
                            u'max_float': 1000.0,
                            u'min_float': 0.0,
                            u'type': u'range-float'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_NAME,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_/-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_VOLUME_GROUP,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_THIN_POOL,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZPOOL,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_/-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZPOOLTHIN,
                            u'type': u'regex',
                            u'value': u'[a-zA-Z0-9_/-]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_FILE_DIRECTORY,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'info': u'Preferred network interface to use',
                            u'key': consts.KEY_STOR_POOL_PREF_NIC,
                            u'type': u'regex',
                            u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                        {   u'info': u'Preferred network interface to use',
                            u'internal': False,
                            u'key': consts.NAMESPC_NVME + '/' + consts.KEY_PREF_NIC,
                            u'type': u'regex',
                            u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                        {   u'default': u'linear',
                            u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_TYPE,
                            u'type': u'symbol',
                            u'values': [   u'linear',
                                           u'striped',
                                           u'mirror',
                                           u'raid0',
                                           u'raid1',
                                           u'raid4',
                                           u'raid5',
                                           u'raid6',
                                           u'raid10',
                                           u'lzma',
                                           u'lz4']},
                        {   u'info': u"Additional parameters added to every 'lvcreate ... ' command",
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_OPTIONS,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'info': u"Additional parameters added to every 'lvcreate --snapshot ... ' command",
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_SNAPSHOT_OPTIONS,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'info': u"Additional parameters added to every 'zfs create ... ' command",
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_CREATE_OPTIONS,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'info': u"Additional parameters added to every 'zfs snapshot ... ' command",
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_SNAPSHOT_OPTIONS,
                            u'type': u'regex',
                            u'value': u'.*'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_WAIT_TIMEOUT_AFTER_CREATE,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'internal': True,
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.NAMESPC_EBS + '/' + consts.KEY_REMOTE,
                            u'type': u'regex',
                            u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                        {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                            u'internal': False,
                            u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                            u'type': u'long'},
                        {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                            u'internal': False,
                            u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                            u'type': u'long'},
                        {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                            u'internal': False,
                            u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                            u'type': u'long'},
                        {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                            u'internal': False,
                            u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                            u'type': u'long'},
                        {   u'info': u'Remote SPDK API host name',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_HOST,
                            u'type': u'regex',
                            u'value': u'.+'},
                        {   u'info': u'Remote SPDK API port',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_PORT,
                            u'type': u'regex',
                            u'value': u'[0-9]+'},
                        {   u'info': u'Remote SPDK API user name',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME,
                            u'type': u'regex',
                            u'value': u'.+'},
                        {   u'info': u'Environment variable containing remote SPDK API user name',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME_ENV,
                            u'type': u'regex',
                            u'value': u'.+'},
                        {   u'info': u'Remote SPDK API password',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW,
                            u'type': u'regex',
                            u'value': u'.+'},
                        {   u'info': u'Environment variable containing remote SPDK API password',
                            u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW_ENV,
                            u'type': u'regex',
                            u'value': u'.+'},
                        {   u'info': u'linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)',
                            u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_VLM_TYPE,
                            u'type': u'symbol',
                            u'values': [u'linear', u'virtual']},
                        {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                            u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                            u'type': u'string'},
                        {   u'info': u'Name of the Exos enclosure',
                            u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_ENCLOSURE,
                            u'type': u'string'},
                        {   u'info': u'Serial number of the Exos pool',
                            u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_POOL_SN,
                            u'type': u'string'},
                        {   u'info': u'The maximum throughput the given storage pool is capable of.',
                            u'key': consts.NAMESPC_AUTOPLACER + '/' + consts.KEY_AUTOPLACE_MAX_THROUGHPUT,
                            u'type': u'long'},
                        {   u'default': u'gp2',
                            u'info': u'Sets the Volume Type for the EBS device (like gp2, gp3, etc..)',
                            u'key': consts.KEY_EBS_VOLUME_TYPE,
                            u'type': u'string'},
                        {   u'info': u"Appends '--skip-disk' to 'drbdadm adjust' commands. Is automatically set if a disk failure is detected. In order to disable, remove this property",
                            u'internal': False,
                            u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_SKIP_DISK,
                            u'type': u'symbol',
                            u'values': [u'True']}],
    u'storagepool-definition': [   {   u'info': u'Default value for MaxFreeCapacityOversubscriptionRatio and MaxTotalCapacityOversubscriptionRatio (default 20)',
                                       u'key': consts.KEY_STOR_POOL_MAX_OVERSUBSCRIPTION_RATIO,
                                       u'max_float': 1000.0,
                                       u'min_float': 0.0,
                                       u'type': u'range-float'},
                                   {   u'info': u'Maximum allowed ratio the remaining free space can be overprovisioned (default 20)',
                                       u'key': consts.KEY_STOR_POOL_MAX_FREE_CAPACITY_OVERSUBSCRIPTION_RATIO,
                                       u'max_float': 1000.0,
                                       u'min_float': 0.0,
                                       u'type': u'range-float'},
                                   {   u'info': u'Maximum allowed ratio the capacity can be overprovisioned (default 20)',
                                       u'key': consts.KEY_STOR_POOL_MAX_TOTAL_CAPACITY_OVERSUBSCRIPTION_RATIO,
                                       u'max_float': 1000.0,
                                       u'min_float': 0.0,
                                       u'type': u'range-float'},
                                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                                       u'internal': False,
                                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                                       u'type': u'long'},
                                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                                       u'internal': False,
                                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                                       u'type': u'long'},
                                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                                       u'internal': False,
                                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                                       u'type': u'long'},
                                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                                       u'internal': False,
                                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                                       u'type': u'long'}],
    u'volume': [   {   u'info': u'Linstor storage pool name to use.',
                       u'key': consts.KEY_STOR_POOL_NAME,
                       u'type': u'regex',
                       u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                   {   u'info': u'Linstor storage pool name to use for external metadata.',
                       u'key': consts.KEY_STOR_POOL_DRBD_META_NAME,
                       u'type': u'regex',
                       u'value': u'^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                       u'internal': False,
                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                       u'type': u'long'},
                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                       u'internal': False,
                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                       u'type': u'long'},
                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                       u'internal': False,
                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                       u'type': u'long'},
                   {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                       u'internal': False,
                       u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                       u'type': u'long'},
                   {   u'drbd_option_name': u'read-balancing',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/read-balancing",
                       u'type': u'symbol',
                       u'values': [   u'prefer-local',
                                      u'prefer-remote',
                                      u'round-robin',
                                      u'least-pending',
                                      u'when-congested-remote',
                                      u'32K-striping',
                                      u'64K-striping',
                                      u'128K-striping',
                                      u'256K-striping',
                                      u'512K-striping',
                                      u'1M-striping']},
                   {   u'drbd_option_name': u'on-io-error',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/on-io-error",
                       u'type': u'symbol',
                       u'values': [   u'pass_on',
                                      u'call-local-io-error',
                                      u'detach']},
                   {   u'default': True,
                       u'drbd_option_name': u'disk-drain',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/disk-drain",
                       u'type': u'boolean'},
                   {   u'drbd_option_name': u'resync-after',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/resync-after",
                       u'type': u'string'},
                   {   u'default': 0,
                       u'drbd_option_name': u'disk-timeout',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/disk-timeout",
                       u'max': 6000,
                       u'min': 0,
                       u'type': u'range',
                       u'unit': u'1/10 seconds',
                       u'unit_prefix': u'1'},
                   {   u'default': False,
                       u'drbd_option_name': u'disable-write-same',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/disable-write-same",
                       u'type': u'boolean'},
                   {   u'default': 0,
                       u'drbd_option_name': u'rs-discard-granularity',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/rs-discard-granularity",
                       u'max': 1048576,
                       u'min': 0,
                       u'type': u'range',
                       u'unit': u'bytes',
                       u'unit_prefix': u'1'},
                   {   u'default': True,
                       u'drbd_option_name': u'disk-flushes',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/disk-flushes",
                       u'type': u'boolean'},
                   {   u'default': 1237,
                       u'drbd_option_name': u'al-extents',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/al-extents",
                       u'max': 65534,
                       u'min': 67,
                       u'type': u'range',
                       u'unit_prefix': u'1'},
                   {   u'default': True,
                       u'drbd_option_name': u'al-updates',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/al-updates",
                       u'type': u'boolean'},
                   {   u'default': True,
                       u'drbd_option_name': u'md-flushes',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/md-flushes",
                       u'type': u'boolean'},
                   {   u'default': False,
                       u'drbd_option_name': u'disk-barrier',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/disk-barrier",
                       u'type': u'boolean'},
                   {   u'default': True,
                       u'drbd_option_name': u'discard-zeroes-if-aligned',
                       u'drbd_res_file_section': u'disk',
                       u'internal': True,
                       u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                       u'type': u'boolean'}],
    u'volume-definition': [   {   u'info': u'Linstor storage pool name to use.',
                                  u'key': consts.KEY_STOR_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'info': u'Linstor storage pool name to use for external metadata.',
                                  u'key': consts.KEY_STOR_POOL_DRBD_META_NAME,
                                  u'type': u'regex',
                                  u'value': u'^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'info': u"Overwrites the generated '<resource-name>_<5 digit volume number>' volume name for migration purposes",
                                  u'key': consts.KEY_STOR_POOL_OVERRIDE_VLM_ID,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u'File system type to use',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_TYPE,
                                  u'type': u'symbol',
                                  u'values': [u'ext4', u'xfs']},
                              {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only Group is given, use 'nobody' as user",
                                  u'info': u'Owner user (name or ID) of the created file system',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_USER,
                                  u'type': u'string'},
                              {   u'default': u"If neither user nor group is given, use the current user of the Linstor process. If only User is given, use the user's group",
                                  u'info': u'Owner group (name or ID) of the created file system',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_GROUP,
                                  u'type': u'string'},
                              {   u'info': u'Additional parameters for the mkfs command',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_FILESYSTEM + '/' + consts.KEY_FS_MKFSPARAMETERS,
                                  u'type': u'string'},
                              {   u'default': u'linear',
                                  u'internal': True,
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_TYPE,
                                  u'type': u'symbol',
                                  u'values': [   u'linear',
                                                 u'striped',
                                                 u'mirror',
                                                 u'raid0',
                                                 u'raid1',
                                                 u'raid4',
                                                 u'raid5',
                                                 u'raid6',
                                                 u'raid10',
                                                 u'lzma',
                                                 u'lz4']},
                              {   u'info': u"Additional parameters added to every 'lvcreate ... ' command",
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_OPTIONS,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u"Additional parameters added to every 'lvcreate --snapshot ... ' command",
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_LVCREATE_SNAPSHOT_OPTIONS,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u"Additional parameters added to every 'zfs create ... ' command",
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_CREATE_OPTIONS,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u"Additional parameters added to every 'zfs snapshot ... ' command",
                                  u'key': consts.NAMESPC_STORAGE_DRIVER + '/' + consts.KEY_STOR_POOL_ZFS_SNAPSHOT_OPTIONS,
                                  u'type': u'regex',
                                  u'value': u'.*'},
                              {   u'info': u'Initial DRBD generation id, if initial sync is skipped, this ID will be set',
                                  u'internal': False,
                                  u'key': consts.KEY_DRBD_CURRENT_GI,
                                  u'type': u'regex',
                                  u'value': u'[a-fA-F0-9]{16}'},
                              {   u'info': u'If set to false it will disable automatic setting of DRBD rs-discard-granularity. If not set or set to true, automatically setting the rs-discard-granularity property might override previously values specified by the user on volume-definition level',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_DRBD_OPTIONS + '/' + consts.KEY_DRBD_AUTO_RS_DISCARD_GRANULARITY,
                                  u'type': u'string'},
                              {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ,
                                  u'type': u'long'},
                              {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE,
                                  u'type': u'long'},
                              {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS,
                                  u'type': u'long'},
                              {   u'info': u'Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_SYS_FS + '/' + consts.KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS,
                                  u'type': u'long'},
                              {   u'info': u'Linstor storage pool name for writecache',
                                  u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'info': u'Size of the writecache in % (0-100) or KiB otherwise',
                                  u'key': consts.NAMESPC_WRITECACHE + '/' + consts.KEY_WRITECACHE_SIZE,
                                  u'type': u'regex',
                                  u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                              {   u'default': u'0',
                                  u'info': u'offset from the start of cache device in 512-byte sectors',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_START_SECTOR,
                                  u'type': u'long'},
                              {   u'default': u'50',
                                  u'info': u'start writeback when the number of used blocks reach this watermark',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_HIGH_WATERMARK,
                                  u'type': u'long'},
                              {   u'default': u'45',
                                  u'info': u'stop writeback when the number of used blocks drops below this watermark',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_LOW_WATERMARK,
                                  u'type': u'long'},
                              {   u'default': u'unlimited',
                                  u'info': u'limit the number of blocks that are in flight during writeback. Setting this value reduces writeback throughput, but it may improve latency of read requests',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_WRITEBACK_JOBS,
                                  u'type': u'long'},
                              {   u'default': u'64 for pmem, 65536 for ssd',
                                  u'info': u'when the application writes this amount of blocks without issuing the FLUSH request, the blocks are automatically committed',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_BLOCKS,
                                  u'type': u'long'},
                              {   u'default': u'1000',
                                  u'info': u'autocommit time in milliseconds. The data is automatically committed if this time passes and no FLUSH request is received',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_AUTOCOMMIT_TIME,
                                  u'type': u'long'},
                              {   u'default': u'On',
                                  u'info': u'"On" results in "fua" as argument, whereas the value "Off" results in "nofua" argument',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_FUA,
                                  u'type': u'symbol',
                                  u'values': [u'On', u'Off']},
                              {   u'info': u'Additional arguments passed through',
                                  u'key': consts.NAMESPC_WRITECACHE_OPTIONS + '/' + consts.KEY_WRITECACHE_OPTION_ADDITIONAL,
                                  u'type': u'string'},
                              {   u'default': u'writethrough',
                                  u'info': u'Operation mode',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_OPERATING_MODE,
                                  u'type': u'symbol',
                                  u'values': [   u'writeback',
                                                 u'writethrough',
                                                 u'passthrough']},
                              {   u'info': u'Name of the storage pool used for the cache metadata. If not specified, this will default to the CachePool property',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'default': u'12288',
                                  u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_META_SIZE,
                                  u'type': u'regex',
                                  u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                              {   u'info': u'Name of the storage pool used for the cache cache device',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'default': u'5%',
                                  u'info': u'Size of the cache in % (0-100) or KiB otherwise.',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_CACHE_SIZE,
                                  u'type': u'regex',
                                  u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                              {   u'default': u'4096',
                                  u'info': u'Block size',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_BLOCK_SIZE,
                                  u'type': u'long'},
                              {   u'default': u'smq',
                                  u'info': u'Replacement policy',
                                  u'key': consts.NAMESPC_CACHE + '/' + consts.KEY_CACHE_POLICY,
                                  u'type': u'symbol',
                                  u'values': [u'mq', u'smq', u'cleaner']},
                              {   u'info': u'Name of the storage pool used for the bcache',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_POOL_NAME,
                                  u'type': u'regex',
                                  u'value': u'^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$'},
                              {   u'default': u'5%',
                                  u'info': u'Size of the cache in % (0-100) or KiB otherwise. Minimum 524288',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_SIZE,
                                  u'type': u'regex',
                                  u'value': u'^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$'},
                              {   u'info': u'Block size',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BLOCKSIZE,
                                  u'type': u'long'},
                              {   u'info': u'Bucket size',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_BUCKETSIZE,
                                  u'type': u'long'},
                              {   u'info': u'Data offset',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DATA_OFFSET,
                                  u'type': u'long'},
                              {   u'info': u'Enable writeback if set to true',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_WRITEBACK,
                                  u'type': u'boolean_true_false'},
                              {   u'info': u'Enable discard if set to true',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_DISCARD,
                                  u'type': u'boolean_true_false'},
                              {   u'info': u'Cache replacement policy. Default: lru',
                                  u'key': consts.NAMESPC_BCACHE + '/' + consts.KEY_BCACHE_CACHE_REPLACEMENT_POLICY,
                                  u'type': u'symbol',
                                  u'values': [u'lru', u'fifo']},
                              {   u'info': u'linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)',
                                  u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_VLM_TYPE,
                                  u'type': u'symbol',
                                  u'values': [u'linear', u'virtual']},
                              {   u'info': u'Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}',
                                  u'key': consts.NAMESPC_EXOS + '/' + consts.KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS,
                                  u'type': u'string'},
                              {   u'default': u'gp2',
                                  u'info': u'Sets the Volume Type for the EBS device (like gp2, gp3, etc..)',
                                  u'key': consts.KEY_EBS_VOLUME_TYPE,
                                  u'type': u'string'},
                              {   u'info': u'External set volume encryption passphrase',
                                  u'internal': False,
                                  u'key': consts.NAMESPC_ENCRYPTION + '/' + consts.KEY_PASSPHRASE,
                                  u'type': u'string'},
                              {   u'drbd_option_name': u'read-balancing',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/read-balancing",
                                  u'type': u'symbol',
                                  u'values': [   u'prefer-local',
                                                 u'prefer-remote',
                                                 u'round-robin',
                                                 u'least-pending',
                                                 u'when-congested-remote',
                                                 u'32K-striping',
                                                 u'64K-striping',
                                                 u'128K-striping',
                                                 u'256K-striping',
                                                 u'512K-striping',
                                                 u'1M-striping']},
                              {   u'drbd_option_name': u'on-io-error',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/on-io-error",
                                  u'type': u'symbol',
                                  u'values': [   u'pass_on',
                                                 u'call-local-io-error',
                                                 u'detach']},
                              {   u'default': True,
                                  u'drbd_option_name': u'disk-drain',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-drain",
                                  u'type': u'boolean'},
                              {   u'drbd_option_name': u'resync-after',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/resync-after",
                                  u'type': u'string'},
                              {   u'default': 0,
                                  u'drbd_option_name': u'disk-timeout',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-timeout",
                                  u'max': 6000,
                                  u'min': 0,
                                  u'type': u'range',
                                  u'unit': u'1/10 seconds',
                                  u'unit_prefix': u'1'},
                              {   u'default': False,
                                  u'drbd_option_name': u'disable-write-same',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disable-write-same",
                                  u'type': u'boolean'},
                              {   u'default': 0,
                                  u'drbd_option_name': u'rs-discard-granularity',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/rs-discard-granularity",
                                  u'max': 1048576,
                                  u'min': 0,
                                  u'type': u'range',
                                  u'unit': u'bytes',
                                  u'unit_prefix': u'1'},
                              {   u'default': True,
                                  u'drbd_option_name': u'disk-flushes',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-flushes",
                                  u'type': u'boolean'},
                              {   u'default': 1237,
                                  u'drbd_option_name': u'al-extents',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/al-extents",
                                  u'max': 65534,
                                  u'min': 67,
                                  u'type': u'range',
                                  u'unit_prefix': u'1'},
                              {   u'default': True,
                                  u'drbd_option_name': u'al-updates',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/al-updates",
                                  u'type': u'boolean'},
                              {   u'default': True,
                                  u'drbd_option_name': u'md-flushes',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/md-flushes",
                                  u'type': u'boolean'},
                              {   u'default': False,
                                  u'drbd_option_name': u'disk-barrier',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/disk-barrier",
                                  u'type': u'boolean'},
                              {   u'default': True,
                                  u'drbd_option_name': u'discard-zeroes-if-aligned',
                                  u'drbd_res_file_section': u'disk',
                                  u'internal': True,
                                  u'key': "DrbdOptions/Disk/discard-zeroes-if-aligned",
                                  u'type': u'boolean'}]}
